SystemOrganization addCategory: #'Mustache-Seaside'!

WAExampleComponent subclass: #MustacheCounter
	instanceVariableNames: 'count mustacheInstance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Seaside'!

!MustacheCounter class methodsFor: 'accessing' stamp: 'JesusMari 12/3/2012 11:51'!
description
	^ 'A very simple Seaside/Mustache application'! !

!MustacheCounter class methodsFor: 'examples' stamp: 'JesusMari 12/3/2012 11:08'!
example
	^ self new! !

!MustacheCounter class methodsFor: 'accessing' stamp: 'JesusMari 12/3/2012 11:50'!
handlerName
	^ 'examples/mustacheCounter'! !

!MustacheCounter class methodsFor: 'initialization' stamp: 'JesusMari 12/3/2012 11:08'!
initialize
	WAAdmin register: self asApplicationAt: self handlerName! !

!MustacheCounter methodsFor: 'accessing' stamp: 'JesusMari 12/3/2012 11:08'!
count
	^ count! !

!MustacheCounter methodsFor: 'accessing' stamp: 'JesusMari 12/3/2012 11:08'!
count: anInteger
	count := anInteger! !

!MustacheCounter methodsFor: 'actions' stamp: 'JesusMari 12/3/2012 11:08'!
decrease
	count := count - 1! !

!MustacheCounter methodsFor: 'actions' stamp: 'JesusMari 12/3/2012 11:08'!
increase
	count := count + 1! !

!MustacheCounter methodsFor: 'initialization' stamp: 'JesusMari 12/5/2012 15:37'!
initialize
	super initialize.
	self count: 0! !

!MustacheCounter methodsFor: 'rendering' stamp: 'JesusMari 12/5/2012 15:39'!
renderContentOn: html
	html mustache 
			basePath:'D:\smalltalk\SCouchViewServer\templates\';
			template:'counter';
			view: (JsonObject fromAssociations: {
						'counter'-> self count.
						'seasideContent'->[
							html heading: count.
							html anchor
								callback: [ self increase ];
								with: '++'.
							html space.
							html anchor
								callback: [ self decrease ];
								with: '--'
							]
					}).
	! !

!MustacheCounter methodsFor: 'accessing' stamp: 'JesusMari 12/3/2012 11:08'!
states
	^ Array with: self! !

!WAHtmlCanvas methodsFor: '*mustache-seaside' stamp: 'JesusMari 12/5/2012 15:36'!
mustache
	^ ( WAMustacheTag on:self)! !

!Mustache class methodsFor: '*mustache-seaside' stamp: 'JesusMari 12/3/2012 11:05'!
toHtml:aTemplate view:aView on:aHtmlCanvas
| compiler tmp templ|

compiler:=self new.
compiler html:aHtmlCanvas.
(aTemplate class superclass = MustacheTemplate class) 
ifTrue:[
		templ:=aTemplate instance render.
		compiler partials:aTemplate partials.
	]
ifFalse:[
	self error:'aTemplate must be a MustacheTemplate subclass'
	].
tmp:= compiler render: templ view: aView. 

^tmp! !

!Mustache methodsFor: '*mustache-seaside' stamp: 'JesusMari 12/3/2012 10:55'!
html: aHtmlCanvas
	html:=aHtmlCanvas! !

!Mustache methodsFor: '*mustache-seaside' stamp: 'JesusMari 12/3/2012 11:04'!
renderTemplateAt: aTemplate view:aView on:htmlCanvas
"High-level function that renders the given 'template' located in the partials node, using the given 'view'  If you need to use any of the template options (see #compile method, you must compile in a separate step, and then call that compiled block) "

self html:htmlCanvas.
^ self render: (self at:aTemplate) view:aView.! !

Object subclass: #WAMustacheTag
	instanceVariableNames: 'mustacheInstance template html'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Seaside'!

!WAMustacheTag class methodsFor: 'as yet unclassified' stamp: 'JesusMari 12/5/2012 15:31'!
on:html
	| i |
	i:=self new.
	i html:html.
	^i! !

!WAMustacheTag methodsFor: 'as yet unclassified' stamp: 'JesusMari 12/5/2012 15:33'!
basePath: aCompletePath
mustacheInstance ifNil:[mustacheInstance:=Mustache instanceFromFolder:aCompletePath]
! !

!WAMustacheTag methodsFor: 'as yet unclassified' stamp: 'JesusMari 12/5/2012 15:41'!
html: aCanvas
html:=aCanvas! !

!WAMustacheTag methodsFor: 'as yet unclassified' stamp: 'JesusMari 12/5/2012 15:24'!
template:aTemplate
template:=aTemplate! !

!WAMustacheTag methodsFor: 'as yet unclassified' stamp: 'JesusMari 12/5/2012 15:29'!
template:aTemplate view:aView
self template:aTemplate.
self view:aView.
! !

!WAMustacheTag methodsFor: 'as yet unclassified' stamp: 'JesusMari 12/5/2012 16:03'!
view: aView
(template isKindOf:String) ifTrue:[
	mustacheInstance renderTemplateAt: template view:aView on:html.
	].
(template isKindOf:MustacheTemplate) ifTrue:[
	Mustache toHtml: template view:aView on:html.
	]! !
MustacheCounter initialize!
